%define oname ppxlib

Name:           ocaml-%{oname}
Version:        0.12.0
Release:        %mkrel 5
Summary:        A comprehensive toolbox for ppx development
License:        MIT
Group:          Development/OCaml
URL:            https://github.com/ocaml-ppx/ppxlib/
Source0:        https://github.com/ocaml-ppx/ppxlib/archive/%{version}.tar.gz
BuildRequires:  ocaml-dune
BuildRequires:  ocaml-compiler
BuildRequires:  ocaml-findlib
BuildRequires:  opam

BuildRequires:  ocaml-base-devel >= 0.11
BuildRequires:  ocaml-migrate-parsetree >= 1.0.9
BuildRequires:  ocaml-ocaml-compiler-libs >= 0.11
BuildRequires:  ocaml-ppx_derivers >= 1.0
BuildRequires:  ocaml-stdio >= 0.11
BuildRequires:  ocaml-result-devel

Obsoletes:      ocaml-ppx_ast < 0.11.0-2
Obsoletes:      ocaml-ppx_core < 1:0.11.0-2
Obsoletes:      ocaml-ppx_driver < 1:0.10.0-4
Obsoletes:      ocaml-ppx_metaquot < 1:0.10.0-4
Obsoletes:      ocaml-ppx_traverse < 0.10.0-4
Obsoletes:      ocaml-ppx_traverse_builtins < 0.10.0-5
Obsoletes:      ocaml-ppx_type_conv < 1:0.10.0-5

%description
A comprehensive toolbox for ppx development. It features:

a OCaml AST / parser / pretty-printer snapshot,to create a full frontend independent of the version of OCaml;
a library for library for ppx rewriters in general, and type-driven code generators in particular;
a feature-full driver for OCaml AST transformers;
a quotation mechanism allowing to write values representing the OCaml AST in the OCaml syntax;
a generator of open recursion classes from type definitions.

%package        devel
Summary:        Development files for %{name}
Group:          Development/OCaml
Requires:       %{name} = %{version}-%{release}

Obsoletes:      ocaml-ppx_ast-devel < 0.11.0-2
Obsoletes:      ocaml-ppx_core-devel < 1:0.11.0-2
Obsoletes:      ocaml-ppx_driver-devel < 1:0.10.0-4
Obsoletes:      ocaml-ppx_metaquot-devel < 1:0.10.0-4
Obsoletes:      ocaml-ppx_traverse-devel < 0.10.0-4
Obsoletes:      ocaml-ppx_traverse_builtins-devel < 0.10.0-5
Obsoletes:      ocaml-ppx_type_conv-devel < 1:0.10.0-5

%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.

%prep
%setup -q -n %{oname}-%{version}
%autopatch -p1

%build
dune build --verbose -p %{oname} %_smp_mflags

%check
# Error: Program cinaps not found in the tree or in PATH
dune runtest || :

%install
opam-installer --prefix=%{buildroot}%{_prefix} --libdir=%{buildroot}%{_libdir}/ocaml %{oname}.install
rm -rf %{buildroot}/usr/doc

# Makes *.cmxs executable such that they will be stripped.
find %{buildroot} -name '*.cmxs' -exec chmod 0755 {} \;

%files
%license LICENSE.md
%dir %{_libdir}/ocaml/%{oname}
%{_libdir}/ocaml/%{oname}/META
%{_libdir}/ocaml/%{oname}/*dune*
%{_libdir}/ocaml/%{oname}/*.a
%{_libdir}/ocaml/%{oname}/*.cmi
%{_libdir}/ocaml/%{oname}/*.cma
%{_libdir}/ocaml/%{oname}/*.cmxa
%{_libdir}/ocaml/%{oname}/*.cmxs
%dir %{_libdir}/ocaml/%{oname}/*/
%{_libdir}/ocaml/%{oname}/*/*.cmi
%{_libdir}/ocaml/%{oname}/*/*.cma
%{_libdir}/ocaml/%{oname}/*/*.a
%{_libdir}/ocaml/%{oname}/*/*.cmxa
%{_libdir}/ocaml/%{oname}/*/*.cmxs
%{_libdir}/ocaml/%{oname}/*/*.exe

%files devel
%doc README.md CHANGES.md
%{_libdir}/ocaml/%{oname}/opam
%{_libdir}/ocaml/%{oname}/*.cmt
%{_libdir}/ocaml/%{oname}/*.cmti
%{_libdir}/ocaml/%{oname}/*.cmx
%{_libdir}/ocaml/%{oname}/*.ml*
%{_libdir}/ocaml/%{oname}/*/*.cmt
%{_libdir}/ocaml/%{oname}/*/*.cmti
%{_libdir}/ocaml/%{oname}/*/*.cmx
%{_libdir}/ocaml/%{oname}/*/*.ml*


%changelog
* Sun Jan 10 2021 pterjan <pterjan> 0.12.0-5.mga8
+ Revision: 1670768
- Rebuild to generate ocamlx provides

* Fri Feb 28 2020 umeabot <umeabot> 0.12.0-4.mga8
+ Revision: 1551746
- Rebuild for ocaml 4.10.0 final

* Thu Feb 20 2020 umeabot <umeabot> 0.12.0-3.mga8
+ Revision: 1545837
- Mageia 8 Mass Rebuild

* Thu Jan 30 2020 tv <tv> 0.12.0-2.mga8
+ Revision: 1485314
- rebuild for new ocaml-stdio)

* Mon Jan 27 2020 tv <tv> 0.12.0-1.mga8
+ Revision: 1483803
- new release + rebuild for ocaml-4.10
- fix URL

* Fri Oct 26 2018 pterjan <pterjan> 0.3.1-5.mga7
+ Revision: 1325548
- Also obsolete -devel packages

* Fri Oct 26 2018 pterjan <pterjan> 0.3.1-4.mga7
+ Revision: 1325547
- Obsolete one more package

* Thu Oct 25 2018 pterjan <pterjan> 0.3.1-3.mga7
+ Revision: 1325517
- Obsolete a bunch of ocaml-ppx* it replaces

* Tue Oct 23 2018 pterjan <pterjan> 0.3.1-2.mga7
+ Revision: 1324586
- Rebuild for ocaml-migrate-parsetree 1.1.0

* Tue Oct 23 2018 pterjan <pterjan> 0.3.1-1.mga7
+ Revision: 1324519
- Fix BuildRequires
- Fix file list
- Fix BuildRequires
- imported package ocaml-ppxlib

